# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Classes

* [`backuppc::client`](#backuppc--client): Manage BackupPC client
* [`backuppc::server`](#backuppc--server): Manage BackPC server

### Data types

* [`Backuppc::BlackoutPeriod`](#Backuppc--BlackoutPeriod): Type to define BlackoutPeriods
* [`Backuppc::DHCPAddressRange`](#Backuppc--DHCPAddressRange): Type to define DHCPAddressRanges

## Classes

### <a name="backuppc--client"></a>`backuppc::client`

Manage BackupPC client

#### Parameters

The following parameters are available in the `backuppc::client` class:

* [`backuppc_hostname`](#-backuppc--client--backuppc_hostname)
* [`ensure`](#-backuppc--client--ensure)
* [`config_name`](#-backuppc--client--config_name)
* [`manage_system_account`](#-backuppc--client--manage_system_account)
* [`system_account`](#-backuppc--client--system_account)
* [`system_account_home_directory`](#-backuppc--client--system_account_home_directory)
* [`system_account_uid`](#-backuppc--client--system_account_uid)
* [`system_account_gid`](#-backuppc--client--system_account_gid)
* [`system_additional_commands`](#-backuppc--client--system_additional_commands)
* [`system_additional_commands_noexec`](#-backuppc--client--system_additional_commands_noexec)
* [`manage_sudo`](#-backuppc--client--manage_sudo)
* [`manage_rsync`](#-backuppc--client--manage_rsync)
* [`rsync_path`](#-backuppc--client--rsync_path)
* [`tar_path`](#-backuppc--client--tar_path)
* [`client_name_alias`](#-backuppc--client--client_name_alias)
* [`xfer_method`](#-backuppc--client--xfer_method)
* [`xfer_loglevel`](#-backuppc--client--xfer_loglevel)
* [`backups_disable`](#-backuppc--client--backups_disable)
* [`full_period`](#-backuppc--client--full_period)
* [`incr_period`](#-backuppc--client--incr_period)
* [`full_keep_cnt`](#-backuppc--client--full_keep_cnt)
* [`full_keep_cnt_min`](#-backuppc--client--full_keep_cnt_min)
* [`full_age_max`](#-backuppc--client--full_age_max)
* [`incr_keep_cnt`](#-backuppc--client--incr_keep_cnt)
* [`incr_keep_cnt_min`](#-backuppc--client--incr_keep_cnt_min)
* [`incr_age_max`](#-backuppc--client--incr_age_max)
* [`blackout_bad_ping_limit`](#-backuppc--client--blackout_bad_ping_limit)
* [`ping_max_msec`](#-backuppc--client--ping_max_msec)
* [`blackout_good_cnt`](#-backuppc--client--blackout_good_cnt)
* [`backup_files_only`](#-backuppc--client--backup_files_only)
* [`backup_files_exclude`](#-backuppc--client--backup_files_exclude)
* [`smb_share_name`](#-backuppc--client--smb_share_name)
* [`smb_share_username`](#-backuppc--client--smb_share_username)
* [`smb_share_passwd`](#-backuppc--client--smb_share_passwd)
* [`smb_client_full_cmd`](#-backuppc--client--smb_client_full_cmd)
* [`smb_client_incr_cmd`](#-backuppc--client--smb_client_incr_cmd)
* [`smb_client_restore_cmd`](#-backuppc--client--smb_client_restore_cmd)
* [`tar_share_name`](#-backuppc--client--tar_share_name)
* [`tar_client_cmd`](#-backuppc--client--tar_client_cmd)
* [`tar_full_args`](#-backuppc--client--tar_full_args)
* [`tar_incr_args`](#-backuppc--client--tar_incr_args)
* [`tar_client_restore_cmd`](#-backuppc--client--tar_client_restore_cmd)
* [`rsync_client_path`](#-backuppc--client--rsync_client_path)
* [`rsync_ssh_args`](#-backuppc--client--rsync_ssh_args)
* [`rsync_args`](#-backuppc--client--rsync_args)
* [`rsync_args_extra`](#-backuppc--client--rsync_args_extra)
* [`rsync_restore_args`](#-backuppc--client--rsync_restore_args)
* [`rsync_restore_args_extra`](#-backuppc--client--rsync_restore_args_extra)
* [`rsync_share_name`](#-backuppc--client--rsync_share_name)
* [`rsyncd_client_port`](#-backuppc--client--rsyncd_client_port)
* [`rsyncd_user_name`](#-backuppc--client--rsyncd_user_name)
* [`rsyncd_passwd`](#-backuppc--client--rsyncd_passwd)
* [`dump_pre_user_cmd`](#-backuppc--client--dump_pre_user_cmd)
* [`dump_post_user_cmd`](#-backuppc--client--dump_post_user_cmd)
* [`dump_pre_share_cmd`](#-backuppc--client--dump_pre_share_cmd)
* [`dump_post_share_cmd`](#-backuppc--client--dump_post_share_cmd)
* [`restore_pre_user_cmd`](#-backuppc--client--restore_pre_user_cmd)
* [`restore_post_user_cmd`](#-backuppc--client--restore_post_user_cmd)
* [`user_cmd_check_status`](#-backuppc--client--user_cmd_check_status)
* [`email_notify_min_days`](#-backuppc--client--email_notify_min_days)
* [`email_from_user_name`](#-backuppc--client--email_from_user_name)
* [`email_admin_user_name`](#-backuppc--client--email_admin_user_name)
* [`email_notify_old_backup_days`](#-backuppc--client--email_notify_old_backup_days)
* [`hosts_file_dhcp`](#-backuppc--client--hosts_file_dhcp)
* [`hosts_file_user`](#-backuppc--client--hosts_file_user)
* [`hosts_file_more_users`](#-backuppc--client--hosts_file_more_users)
* [`export_sshkey`](#-backuppc--client--export_sshkey)

##### <a name="-backuppc--client--backuppc_hostname"></a>`backuppc_hostname`

Data type: `Stdlib::Host`

The BackupPC hostname
This is used to match which BackupPC server is authorized for backups

##### <a name="-backuppc--client--ensure"></a>`ensure`

Data type: `Enum['present','absent']`

Whether to add or remove BackupPC client resources

Default value: `'present'`

##### <a name="-backuppc--client--config_name"></a>`config_name`

Data type: `String`

Name of BackupPC client config

Default value: `$facts['networking']['fqdn']`

##### <a name="-backuppc--client--manage_system_account"></a>`manage_system_account`

Data type: `Boolean`

Manage the user account used to perform backups

Default value: `true`

##### <a name="-backuppc--client--system_account"></a>`system_account`

Data type: `String`

Account used to perform backups

Default value: `'backup'`

##### <a name="-backuppc--client--system_account_home_directory"></a>`system_account_home_directory`

Data type: `Stdlib::Absolutepath`

The home directory of backup user

Default value: `'/var/backups'`

##### <a name="-backuppc--client--system_account_uid"></a>`system_account_uid`

Data type: `Optional[Integer]`

Backup user UID

Default value: `undef`

##### <a name="-backuppc--client--system_account_gid"></a>`system_account_gid`

Data type: `Optional[Integer]`

Backup user and group GID

Default value: `undef`

##### <a name="-backuppc--client--system_additional_commands"></a>`system_additional_commands`

Data type: `Array`

Authorize commands for backup user via sudo

Default value: `[]`

##### <a name="-backuppc--client--system_additional_commands_noexec"></a>`system_additional_commands_noexec`

Data type: `Array`

Authorize commands for backup user via sudo with NOEXEC

Default value: `[]`

##### <a name="-backuppc--client--manage_sudo"></a>`manage_sudo`

Data type: `Boolean`

Include sudo class

Default value: `false`

##### <a name="-backuppc--client--manage_rsync"></a>`manage_rsync`

Data type: `Boolean`

Manage rsync package

Default value: `true`

##### <a name="-backuppc--client--rsync_path"></a>`rsync_path`

Data type: `Stdlib::Absolutepath`

rsync path

Default value: `'/usr/bin/rsync'`

##### <a name="-backuppc--client--tar_path"></a>`tar_path`

Data type: `Stdlib::Absolutepath`

tar path

Default value: `'/bin/gtar'`

##### <a name="-backuppc--client--client_name_alias"></a>`client_name_alias`

Data type: `Optional[String]`

See config.pl ClientNameAlias

Default value: `undef`

##### <a name="-backuppc--client--xfer_method"></a>`xfer_method`

Data type: `String`

See config.pl XferMethod

Default value: `'rsync'`

##### <a name="-backuppc--client--xfer_loglevel"></a>`xfer_loglevel`

Data type: `Integer`

See config.pl XferLogLevel

Default value: `1`

##### <a name="-backuppc--client--backups_disable"></a>`backups_disable`

Data type: `Optional[Boolean]`

See config.pl BackupsDisable

Default value: `undef`

##### <a name="-backuppc--client--full_period"></a>`full_period`

Data type: `Optional[Variant[Integer, Float]]`

See config.pl FullPeriod

Default value: `undef`

##### <a name="-backuppc--client--incr_period"></a>`incr_period`

Data type: `Optional[Variant[Integer, Float]]`

See config.pl IncrPeriod

Default value: `undef`

##### <a name="-backuppc--client--full_keep_cnt"></a>`full_keep_cnt`

Data type: `Optional[Variant[Array[Integer], Integer]]`

See config.pl FullKeepCnt

Default value: `undef`

##### <a name="-backuppc--client--full_keep_cnt_min"></a>`full_keep_cnt_min`

Data type: `Optional[Integer]`

See config.pl FullKeepCntMin

Default value: `undef`

##### <a name="-backuppc--client--full_age_max"></a>`full_age_max`

Data type: `Optional[Integer]`

See config.pl FullAgeMax

Default value: `undef`

##### <a name="-backuppc--client--incr_keep_cnt"></a>`incr_keep_cnt`

Data type: `Optional[Integer]`

See config.pl IncrKeepCnt

Default value: `undef`

##### <a name="-backuppc--client--incr_keep_cnt_min"></a>`incr_keep_cnt_min`

Data type: `Optional[Integer]`

See config.pl IncrKeepCntMin

Default value: `undef`

##### <a name="-backuppc--client--incr_age_max"></a>`incr_age_max`

Data type: `Optional[Integer]`

See config.pl IncrAgeMax

Default value: `undef`

##### <a name="-backuppc--client--blackout_bad_ping_limit"></a>`blackout_bad_ping_limit`

Data type: `Optional[Integer]`

See config.pl BlackoutBadPingLimit

Default value: `undef`

##### <a name="-backuppc--client--ping_max_msec"></a>`ping_max_msec`

Data type: `Optional[Integer]`

See config.pl PingMaxMsec

Default value: `undef`

##### <a name="-backuppc--client--blackout_good_cnt"></a>`blackout_good_cnt`

Data type: `Optional[Integer]`

See config.pl BlackoutGoodCnt

Default value: `undef`

##### <a name="-backuppc--client--backup_files_only"></a>`backup_files_only`

Data type: `Optional[Variant[Hash,Array,String]]`

See config.pl BackupFilesOnly

Default value: `undef`

##### <a name="-backuppc--client--backup_files_exclude"></a>`backup_files_exclude`

Data type: `Optional[Variant[Hash,Array,String]]`

See config.pl BackupFilesExclude

Default value: `undef`

##### <a name="-backuppc--client--smb_share_name"></a>`smb_share_name`

Data type: `Optional[String]`

See config.pl SmbShareName

Default value: `undef`

##### <a name="-backuppc--client--smb_share_username"></a>`smb_share_username`

Data type: `Optional[String]`

See config.pl SmbShareUserName

Default value: `undef`

##### <a name="-backuppc--client--smb_share_passwd"></a>`smb_share_passwd`

Data type: `Optional[String]`

See config.pl SmbSharePasswd

Default value: `undef`

##### <a name="-backuppc--client--smb_client_full_cmd"></a>`smb_client_full_cmd`

Data type: `Optional[String]`

See config.pl SmbClientFullCmd

Default value: `undef`

##### <a name="-backuppc--client--smb_client_incr_cmd"></a>`smb_client_incr_cmd`

Data type: `Optional[String]`

See config.pl SmbClientIncrCmd

Default value: `undef`

##### <a name="-backuppc--client--smb_client_restore_cmd"></a>`smb_client_restore_cmd`

Data type: `Optional[String]`

See config.pl SmbClientRestoreCmd

Default value: `undef`

##### <a name="-backuppc--client--tar_share_name"></a>`tar_share_name`

Data type: `Optional[Variant[Array, String]]`

See config.pl TarShareName

Default value: `undef`

##### <a name="-backuppc--client--tar_client_cmd"></a>`tar_client_cmd`

Data type: `Optional[String]`

See config.pl TarClientCmd

Default value: `undef`

##### <a name="-backuppc--client--tar_full_args"></a>`tar_full_args`

Data type: `Optional[String]`

See config.pl TarFullArgs

Default value: `undef`

##### <a name="-backuppc--client--tar_incr_args"></a>`tar_incr_args`

Data type: `Optional[String]`

See config.pl TarIncrArgs

Default value: `undef`

##### <a name="-backuppc--client--tar_client_restore_cmd"></a>`tar_client_restore_cmd`

Data type: `Optional[String]`

See config.pl TarClientRestoreCmd

Default value: `undef`

##### <a name="-backuppc--client--rsync_client_path"></a>`rsync_client_path`

Data type: `Optional[String]`

See config.pl RsyncClientPath

Default value: `undef`

##### <a name="-backuppc--client--rsync_ssh_args"></a>`rsync_ssh_args`

Data type: `Optional[Array]`

See config.pl RsyncSshArgs

Default value: `undef`

##### <a name="-backuppc--client--rsync_args"></a>`rsync_args`

Data type: `Optional[Array]`

See config.pl RsyncArgs

Default value: `undef`

##### <a name="-backuppc--client--rsync_args_extra"></a>`rsync_args_extra`

Data type: `Optional[Array]`

See config.pl RsyncArgsExtra

Default value: `undef`

##### <a name="-backuppc--client--rsync_restore_args"></a>`rsync_restore_args`

Data type: `Optional[Array]`

See config.pl RsyncRestoreArgs

Default value: `undef`

##### <a name="-backuppc--client--rsync_restore_args_extra"></a>`rsync_restore_args_extra`

Data type: `Optional[Array]`

See config.pl RsyncRestoreArgsExtra

Default value: `undef`

##### <a name="-backuppc--client--rsync_share_name"></a>`rsync_share_name`

Data type: `Optional[Variant[Array, String]]`

See config.pl RsyncShareName

Default value: `undef`

##### <a name="-backuppc--client--rsyncd_client_port"></a>`rsyncd_client_port`

Data type: `Optional[Integer]`

See config.pl RsyncdClientPort

Default value: `undef`

##### <a name="-backuppc--client--rsyncd_user_name"></a>`rsyncd_user_name`

Data type: `Optional[String]`

See config.pl RsyncdUserName

Default value: `undef`

##### <a name="-backuppc--client--rsyncd_passwd"></a>`rsyncd_passwd`

Data type: `Optional[String]`

See config.pl RsyncdPasswd

Default value: `undef`

##### <a name="-backuppc--client--dump_pre_user_cmd"></a>`dump_pre_user_cmd`

Data type: `Optional[String]`

See config.pl DumpPreUserCmd

Default value: `undef`

##### <a name="-backuppc--client--dump_post_user_cmd"></a>`dump_post_user_cmd`

Data type: `Optional[String]`

See config.pl DumpPostUserCmd

Default value: `undef`

##### <a name="-backuppc--client--dump_pre_share_cmd"></a>`dump_pre_share_cmd`

Data type: `Optional[String]`

See config.pl DumpPreShareCmd

Default value: `undef`

##### <a name="-backuppc--client--dump_post_share_cmd"></a>`dump_post_share_cmd`

Data type: `Optional[String]`

See config.pl DumpPostShareCmd

Default value: `undef`

##### <a name="-backuppc--client--restore_pre_user_cmd"></a>`restore_pre_user_cmd`

Data type: `Optional[String]`

See config.pl RestorePreUserCmd

Default value: `undef`

##### <a name="-backuppc--client--restore_post_user_cmd"></a>`restore_post_user_cmd`

Data type: `Optional[String]`

See config.pl RestorePostUserCmd

Default value: `undef`

##### <a name="-backuppc--client--user_cmd_check_status"></a>`user_cmd_check_status`

Data type: `Optional[Boolean]`

See config.pl UserCmdCheckStatus

Default value: `undef`

##### <a name="-backuppc--client--email_notify_min_days"></a>`email_notify_min_days`

Data type: `Optional[Variant[Integer, Float]]`

See config.pl EMailNotifyMinDays

Default value: `undef`

##### <a name="-backuppc--client--email_from_user_name"></a>`email_from_user_name`

Data type: `Optional[String]`

See config.pl EMailFromUserName

Default value: `undef`

##### <a name="-backuppc--client--email_admin_user_name"></a>`email_admin_user_name`

Data type: `Optional[String]`

See config.pl EMailAdminUserName

Default value: `undef`

##### <a name="-backuppc--client--email_notify_old_backup_days"></a>`email_notify_old_backup_days`

Data type: `Optional[Integer]`

See config.pl EMailNotifyOldBackupDays

Default value: `undef`

##### <a name="-backuppc--client--hosts_file_dhcp"></a>`hosts_file_dhcp`

Data type: `Boolean`

Whether to use enable DHCP in hosts file

Default value: `false`

##### <a name="-backuppc--client--hosts_file_user"></a>`hosts_file_user`

Data type: `String`

Hosts file user

Default value: `'backuppc'`

##### <a name="-backuppc--client--hosts_file_more_users"></a>`hosts_file_more_users`

Data type: `Array`

Hosts file more users

Default value: `[]`

##### <a name="-backuppc--client--export_sshkey"></a>`export_sshkey`

Data type: `Boolean`

Set whether to export the SSH key for the backup client to BackupPC server

Default value: `true`

### <a name="backuppc--server"></a>`backuppc::server`

Manage BackPC server

#### Parameters

The following parameters are available in the `backuppc::server` class:

* [`package_name`](#-backuppc--server--package_name)
* [`manage_repo`](#-backuppc--server--manage_repo)
* [`service_name`](#-backuppc--server--service_name)
* [`config_dir`](#-backuppc--server--config_dir)
* [`replace_config`](#-backuppc--server--replace_config)
* [`manage_topdir`](#-backuppc--server--manage_topdir)
* [`topdir`](#-backuppc--server--topdir)
* [`install_dir`](#-backuppc--server--install_dir)
* [`log_dir`](#-backuppc--server--log_dir)
* [`run_dir`](#-backuppc--server--run_dir)
* [`df_path`](#-backuppc--server--df_path)
* [`cat_path`](#-backuppc--server--cat_path)
* [`par_path`](#-backuppc--server--par_path)
* [`gzip_path`](#-backuppc--server--gzip_path)
* [`bzip2_path`](#-backuppc--server--bzip2_path)
* [`rsync_path`](#-backuppc--server--rsync_path)
* [`tar_path`](#-backuppc--server--tar_path)
* [`rsync_bpc_path`](#-backuppc--server--rsync_bpc_path)
* [`ping_path`](#-backuppc--server--ping_path)
* [`ping6_path`](#-backuppc--server--ping6_path)
* [`cgi_dir`](#-backuppc--server--cgi_dir)
* [`cgi_image_dir`](#-backuppc--server--cgi_image_dir)
* [`cgi_image_dir_url`](#-backuppc--server--cgi_image_dir_url)
* [`apache_group`](#-backuppc--server--apache_group)
* [`server_host`](#-backuppc--server--server_host)
* [`wakeup_schedule`](#-backuppc--server--wakeup_schedule)
* [`pool_v3_enabled`](#-backuppc--server--pool_v3_enabled)
* [`max_backups`](#-backuppc--server--max_backups)
* [`max_user_backups`](#-backuppc--server--max_user_backups)
* [`max_pending_cmds`](#-backuppc--server--max_pending_cmds)
* [`max_backup_pc_nightly_jobs`](#-backuppc--server--max_backup_pc_nightly_jobs)
* [`backup_pc_nightly_period`](#-backuppc--server--backup_pc_nightly_period)
* [`pool_size_nightly_update_period`](#-backuppc--server--pool_size_nightly_update_period)
* [`pool_nightly_digest_check_percent`](#-backuppc--server--pool_nightly_digest_check_percent)
* [`ref_cnt_fsck`](#-backuppc--server--ref_cnt_fsck)
* [`max_old_log_files`](#-backuppc--server--max_old_log_files)
* [`df_max_usage_pct`](#-backuppc--server--df_max_usage_pct)
* [`df_max_inode_usage_pct`](#-backuppc--server--df_max_inode_usage_pct)
* [`dhcp_address_ranges`](#-backuppc--server--dhcp_address_ranges)
* [`full_period`](#-backuppc--server--full_period)
* [`incr_period`](#-backuppc--server--incr_period)
* [`fill_cycle`](#-backuppc--server--fill_cycle)
* [`full_keep_cnt`](#-backuppc--server--full_keep_cnt)
* [`full_age_max`](#-backuppc--server--full_age_max)
* [`incr_keep_cnt`](#-backuppc--server--incr_keep_cnt)
* [`incr_age_max`](#-backuppc--server--incr_age_max)
* [`restore_info_keep_cnt`](#-backuppc--server--restore_info_keep_cnt)
* [`archive_info_keep_cnt`](#-backuppc--server--archive_info_keep_cnt)
* [`blackout_good_cnt`](#-backuppc--server--blackout_good_cnt)
* [`blackout_periods`](#-backuppc--server--blackout_periods)
* [`blackout_zero_files_is_fatal`](#-backuppc--server--blackout_zero_files_is_fatal)
* [`rsync_cmd_default_user`](#-backuppc--server--rsync_cmd_default_user)
* [`rsync_client_path`](#-backuppc--server--rsync_client_path)
* [`rsync_args`](#-backuppc--server--rsync_args)
* [`rsync_args_extra`](#-backuppc--server--rsync_args_extra)
* [`rsync_full_args_extra`](#-backuppc--server--rsync_full_args_extra)
* [`rsync_incr_args_extra`](#-backuppc--server--rsync_incr_args_extra)
* [`rsync_restore_args`](#-backuppc--server--rsync_restore_args)
* [`rsync_restore_args_extra`](#-backuppc--server--rsync_restore_args_extra)
* [`compress_level`](#-backuppc--server--compress_level)
* [`email_notify_min_days`](#-backuppc--server--email_notify_min_days)
* [`email_from_user_name`](#-backuppc--server--email_from_user_name)
* [`email_admin_user_name`](#-backuppc--server--email_admin_user_name)
* [`email_user_dest_domain`](#-backuppc--server--email_user_dest_domain)
* [`email_notify_old_backup_days`](#-backuppc--server--email_notify_old_backup_days)
* [`email_headers`](#-backuppc--server--email_headers)
* [`cgi_admin_user_group`](#-backuppc--server--cgi_admin_user_group)
* [`cgi_admin_users`](#-backuppc--server--cgi_admin_users)
* [`cgi_url`](#-backuppc--server--cgi_url)
* [`manage_user`](#-backuppc--server--manage_user)
* [`user_uid`](#-backuppc--server--user_uid)
* [`user_shell`](#-backuppc--server--user_shell)
* [`user_gid`](#-backuppc--server--user_gid)

##### <a name="-backuppc--server--package_name"></a>`package_name`

Data type: `String`

Package name

Default value: `'BackupPC'`

##### <a name="-backuppc--server--manage_repo"></a>`manage_repo`

Data type: `Boolean`

Manage repo
Only applies to EL systems to manage EPEL

Default value: `true`

##### <a name="-backuppc--server--service_name"></a>`service_name`

Data type: `String`

Service name

Default value: `'backuppc'`

##### <a name="-backuppc--server--config_dir"></a>`config_dir`

Data type: `Stdlib::Absolutepath`

Config directory

Default value: `'/etc/BackupPC'`

##### <a name="-backuppc--server--replace_config"></a>`replace_config`

Data type: `Boolean`

Set if replace BackupPC config.pl

Default value: `true`

##### <a name="-backuppc--server--manage_topdir"></a>`manage_topdir`

Data type: `Boolean`

Manage BackupPC topdir

Default value: `true`

##### <a name="-backuppc--server--topdir"></a>`topdir`

Data type: `Stdlib::Absolutepath`

Path to topdir

Default value: `'/var/lib/BackupPC'`

##### <a name="-backuppc--server--install_dir"></a>`install_dir`

Data type: `Stdlib::Absolutepath`

BackupPC install directory

Default value: `'/usr/share/BackupPC'`

##### <a name="-backuppc--server--log_dir"></a>`log_dir`

Data type: `Stdlib::Absolutepath`

Log directory

Default value: `'/var/log/BackupPC'`

##### <a name="-backuppc--server--run_dir"></a>`run_dir`

Data type: `Stdlib::Absolutepath`

Run dir

Default value: `'/var/run/BackupPC'`

##### <a name="-backuppc--server--df_path"></a>`df_path`

Data type: `Stdlib::Absolutepath`

Path to df

Default value: `'/usr/bin/df'`

##### <a name="-backuppc--server--cat_path"></a>`cat_path`

Data type: `Stdlib::Absolutepath`

Path to cat

Default value: `'/usr/bin/cat'`

##### <a name="-backuppc--server--par_path"></a>`par_path`

Data type: `Stdlib::Absolutepath`

Path to par2

Default value: `'/usr/bin/par2'`

##### <a name="-backuppc--server--gzip_path"></a>`gzip_path`

Data type: `Stdlib::Absolutepath`

Path to gzip

Default value: `'/usr/bin/gzip'`

##### <a name="-backuppc--server--bzip2_path"></a>`bzip2_path`

Data type: `Stdlib::Absolutepath`

Path to bzip2

Default value: `'/usr/bin/bzip2'`

##### <a name="-backuppc--server--rsync_path"></a>`rsync_path`

Data type: `Stdlib::Absolutepath`

Path to rsync

Default value: `'/usr/bin/rsync'`

##### <a name="-backuppc--server--tar_path"></a>`tar_path`

Data type: `Stdlib::Absolutepath`

Path to tar

Default value: `'/bin/gtar'`

##### <a name="-backuppc--server--rsync_bpc_path"></a>`rsync_bpc_path`

Data type: `Stdlib::Absolutepath`

Path to rsync_bpc

Default value: `'/usr/bin/rsync_bpc'`

##### <a name="-backuppc--server--ping_path"></a>`ping_path`

Data type: `Stdlib::Absolutepath`

Path to ping

Default value: `'/usr/sbin/ping'`

##### <a name="-backuppc--server--ping6_path"></a>`ping6_path`

Data type: `Stdlib::Absolutepath`

Path to ping6

Default value: `'/usr/sbin/ping6'`

##### <a name="-backuppc--server--cgi_dir"></a>`cgi_dir`

Data type: `Stdlib::Absolutepath`

CGI directory

Default value: `'/usr/libexec/BackupPC'`

##### <a name="-backuppc--server--cgi_image_dir"></a>`cgi_image_dir`

Data type: `Stdlib::Absolutepath`

CGI image directory

Default value: `'/usr/share/BackupPC/html'`

##### <a name="-backuppc--server--cgi_image_dir_url"></a>`cgi_image_dir_url`

Data type: `Stdlib::Absolutepath`

CGI image directory URL

Default value: `'/BackupPC/images'`

##### <a name="-backuppc--server--apache_group"></a>`apache_group`

Data type: `String`

Apache group

Default value: `'apache'`

##### <a name="-backuppc--server--server_host"></a>`server_host`

Data type: `Stdlib::Fqdn`

config.pl ServerHost

Default value: `$facts['networking']['fqdn']`

##### <a name="-backuppc--server--wakeup_schedule"></a>`wakeup_schedule`

Data type: `Array[Integer]`

config.pl WakeupSchedule

Default value: `[1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23]`

##### <a name="-backuppc--server--pool_v3_enabled"></a>`pool_v3_enabled`

Data type: `Boolean`

config.pl PoolV3Enabled

Default value: `false`

##### <a name="-backuppc--server--max_backups"></a>`max_backups`

Data type: `Integer`

config.pl MaxBackups

Default value: `4`

##### <a name="-backuppc--server--max_user_backups"></a>`max_user_backups`

Data type: `Integer`

config.pl MaxUserBackups

Default value: `4`

##### <a name="-backuppc--server--max_pending_cmds"></a>`max_pending_cmds`

Data type: `Integer`

config.pl MaxPendingCmds

Default value: `15`

##### <a name="-backuppc--server--max_backup_pc_nightly_jobs"></a>`max_backup_pc_nightly_jobs`

Data type: `Integer`

config.pl MaxBackupPCNightlyJobs

Default value: `2`

##### <a name="-backuppc--server--backup_pc_nightly_period"></a>`backup_pc_nightly_period`

Data type: `Integer`

config.pl BackupPCNightlyPeriod

Default value: `1`

##### <a name="-backuppc--server--pool_size_nightly_update_period"></a>`pool_size_nightly_update_period`

Data type: `Integer`

config.pl PoolSizeNightlyUpdatePeriod

Default value: `16`

##### <a name="-backuppc--server--pool_nightly_digest_check_percent"></a>`pool_nightly_digest_check_percent`

Data type: `Integer`

config.pl PoolNightlyDigestCheckPercent

Default value: `1`

##### <a name="-backuppc--server--ref_cnt_fsck"></a>`ref_cnt_fsck`

Data type: `Integer`

config.pl RefCntFsck

Default value: `1`

##### <a name="-backuppc--server--max_old_log_files"></a>`max_old_log_files`

Data type: `Integer`

config.pl MaxOldLogFiles

Default value: `14`

##### <a name="-backuppc--server--df_max_usage_pct"></a>`df_max_usage_pct`

Data type: `Integer`

config.pl DfMaxUsagePct

Default value: `95`

##### <a name="-backuppc--server--df_max_inode_usage_pct"></a>`df_max_inode_usage_pct`

Data type: `Integer`

config.pl DfMaxInodeUsagePct

Default value: `95`

##### <a name="-backuppc--server--dhcp_address_ranges"></a>`dhcp_address_ranges`

Data type: `Array[Backuppc::DHCPAddressRange]`

config.pl DHCPAddressRanges

Default value: `[]`

##### <a name="-backuppc--server--full_period"></a>`full_period`

Data type: `Variant[Integer, Float]`

config.pl FullPeriod

Default value: `6.97`

##### <a name="-backuppc--server--incr_period"></a>`incr_period`

Data type: `Variant[Integer, Float]`

config.pl IncrPeriod

Default value: `0.97`

##### <a name="-backuppc--server--fill_cycle"></a>`fill_cycle`

Data type: `Integer`

config.pl FillCycle

Default value: `0`

##### <a name="-backuppc--server--full_keep_cnt"></a>`full_keep_cnt`

Data type: `Variant[Array[Integer], Integer]`

config.pl FullKeepCnt

Default value: `[1]`

##### <a name="-backuppc--server--full_age_max"></a>`full_age_max`

Data type: `Integer`

config.pl FullAgeMax

Default value: `180`

##### <a name="-backuppc--server--incr_keep_cnt"></a>`incr_keep_cnt`

Data type: `Integer`

config.pl IncrKeepCnt

Default value: `6`

##### <a name="-backuppc--server--incr_age_max"></a>`incr_age_max`

Data type: `Integer`

config.pl IncrAgeMax

Default value: `30`

##### <a name="-backuppc--server--restore_info_keep_cnt"></a>`restore_info_keep_cnt`

Data type: `Integer`

config.pl RestoreInfoKeepCnt

Default value: `10`

##### <a name="-backuppc--server--archive_info_keep_cnt"></a>`archive_info_keep_cnt`

Data type: `Integer`

config.pl ArchiveInfoKeepCnt

Default value: `10`

##### <a name="-backuppc--server--blackout_good_cnt"></a>`blackout_good_cnt`

Data type: `Integer`

config.pl BlackoutGoodCnt

Default value: `7`

##### <a name="-backuppc--server--blackout_periods"></a>`blackout_periods`

Data type: `Array[Backuppc::BlackoutPeriod]`

config.pl BlackoutPeriods

Default value:

```puppet
[
    {
      hour_begin => 7.0,
      hour_end   => 19.5,
      week_days  => [1, 2, 3, 4, 5],
    }
  ]
```

##### <a name="-backuppc--server--blackout_zero_files_is_fatal"></a>`blackout_zero_files_is_fatal`

Data type: `Boolean`

config.pl BackupZeroFilesIsFatal

Default value: `true`

##### <a name="-backuppc--server--rsync_cmd_default_user"></a>`rsync_cmd_default_user`

Data type: `String`

Default user for rsync backups

Default value: `'root'`

##### <a name="-backuppc--server--rsync_client_path"></a>`rsync_client_path`

Data type: `String`

config.pl RsyncClientPath

Default value: `'/usr/bin/rsync'`

##### <a name="-backuppc--server--rsync_args"></a>`rsync_args`

Data type: `Array`

config.pl RsyncArgs

Default value: `[]`

##### <a name="-backuppc--server--rsync_args_extra"></a>`rsync_args_extra`

Data type: `Array`

config.pl RsyncArgsExtra

Default value: `[]`

##### <a name="-backuppc--server--rsync_full_args_extra"></a>`rsync_full_args_extra`

Data type: `Array`

config.pl RsyncFullArgsExtra

Default value: `['--checksum']`

##### <a name="-backuppc--server--rsync_incr_args_extra"></a>`rsync_incr_args_extra`

Data type: `Array`

config.pl RsyncIncrArgsExtra

Default value: `[]`

##### <a name="-backuppc--server--rsync_restore_args"></a>`rsync_restore_args`

Data type: `Array`

config.pl RsyncRestoreArgs

Default value: `[]`

##### <a name="-backuppc--server--rsync_restore_args_extra"></a>`rsync_restore_args_extra`

Data type: `Array`

config.pl RsyncRestoreArgsExtra

Default value: `[]`

##### <a name="-backuppc--server--compress_level"></a>`compress_level`

Data type: `Integer[1,9]`

config.pl CompressLevel

Default value: `3`

##### <a name="-backuppc--server--email_notify_min_days"></a>`email_notify_min_days`

Data type: `Variant[Integer, Float]`

config.pl EMailNotifyMinDays

Default value: `2.5`

##### <a name="-backuppc--server--email_from_user_name"></a>`email_from_user_name`

Data type: `String`

config.pl EMailFromUserName

Default value: `'backuppc'`

##### <a name="-backuppc--server--email_admin_user_name"></a>`email_admin_user_name`

Data type: `String`

config.pl EMailAdminUserName

Default value: `'backuppc'`

##### <a name="-backuppc--server--email_user_dest_domain"></a>`email_user_dest_domain`

Data type: `Optional[String]`

config.pl EMailUserDestDomain

Default value: `undef`

##### <a name="-backuppc--server--email_notify_old_backup_days"></a>`email_notify_old_backup_days`

Data type: `Variant[Integer, Float]`

config.pl EMailNotifyOldBackupDays

Default value: `7.0`

##### <a name="-backuppc--server--email_headers"></a>`email_headers`

Data type: `Hash`

config.pl EMailHeaders

Default value:

```puppet
{
    'MIME-Version' => 1.0,
    'Content-Type' => 'text/plain; charset="utf-8"',
  }
```

##### <a name="-backuppc--server--cgi_admin_user_group"></a>`cgi_admin_user_group`

Data type: `Variant[Array[String], String]`

config.pl CgiAdminUserGroup

Default value: `[]`

##### <a name="-backuppc--server--cgi_admin_users"></a>`cgi_admin_users`

Data type: `Variant[Array[String], String]`

config.pl CgiAdminUsers

Default value: `[]`

##### <a name="-backuppc--server--cgi_url"></a>`cgi_url`

Data type: `Variant[Stdlib::HTTPUrl, Stdlib::HTTPSUrl]`

config.pl CgiURL

Default value: `"http://${facts['networking']['fqdn']}/backuppc"`

##### <a name="-backuppc--server--manage_user"></a>`manage_user`

Data type: `Boolean`

Manage BackupPC user and group

Default value: `true`

##### <a name="-backuppc--server--user_uid"></a>`user_uid`

Data type: `Optional[Integer]`

BackupPC UID

Default value: `undef`

##### <a name="-backuppc--server--user_shell"></a>`user_shell`

Data type: `Stdlib::Absolutepath`

BackupPC user shell

Default value: `'/sbin/nologin'`

##### <a name="-backuppc--server--user_gid"></a>`user_gid`

Data type: `Optional[Integer]`

BackupPC user and group GID

Default value: `undef`

## Data types

### <a name="Backuppc--BlackoutPeriod"></a>`Backuppc::BlackoutPeriod`

Type to define BlackoutPeriods

Alias of

```puppet
Struct[{
  'hour_begin' => Variant[Integer, Float],
  'hour_end'   => Variant[Integer, Float],
  'week_days'  => Array[Integer],
}]
```

### <a name="Backuppc--DHCPAddressRange"></a>`Backuppc::DHCPAddressRange`

Type to define DHCPAddressRanges

Alias of

```puppet
Struct[{
  'ip_addr_base' => String,
  'first'        => Integer,
  'last'         => Integer,
}]
```

